"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExternalLink = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Wavefront External Link Resource. This allows external links to be created, updated, and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * const basic = new wavefront.ExternalLink("basic", {
 *     name: "External Link",
 *     description: "An external link description",
 *     template: "https://example.com/source={{{source}}}&startTime={{startEpochMillis}}",
 * });
 * ```
 *
 * ## Import
 *
 * Maintenance windows can be imported by using the `id`, e.g.:
 *
 * ```sh
 * $ pulumi import wavefront:index/externalLink:ExternalLink basic fVj6fz6zYC4aBkID
 * ```
 */
class ExternalLink extends pulumi.CustomResource {
    /**
     * Get an existing ExternalLink resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ExternalLink(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ExternalLink.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ExternalLink.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["isLogIntegration"] = state ? state.isLogIntegration : undefined;
            resourceInputs["metricFilterRegex"] = state ? state.metricFilterRegex : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["pointTagFilterRegexes"] = state ? state.pointTagFilterRegexes : undefined;
            resourceInputs["sourceFilterRegex"] = state ? state.sourceFilterRegex : undefined;
            resourceInputs["template"] = state ? state.template : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.description === undefined) && !opts.urn) {
                throw new Error("Missing required property 'description'");
            }
            if ((!args || args.template === undefined) && !opts.urn) {
                throw new Error("Missing required property 'template'");
            }
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["isLogIntegration"] = args ? args.isLogIntegration : undefined;
            resourceInputs["metricFilterRegex"] = args ? args.metricFilterRegex : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["pointTagFilterRegexes"] = args ? args.pointTagFilterRegexes : undefined;
            resourceInputs["sourceFilterRegex"] = args ? args.sourceFilterRegex : undefined;
            resourceInputs["template"] = args ? args.template : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(ExternalLink.__pulumiType, name, resourceInputs, opts);
    }
}
exports.ExternalLink = ExternalLink;
/** @internal */
ExternalLink.__pulumiType = 'wavefront:index/externalLink:ExternalLink';
//# sourceMappingURL=externalLink.js.map